package cv07;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Karel Cemus
 */
public class Pub {

    /** maximalni pocet stolu */
    private static final int NUMBER_OF_TABLES = 3;

    /** maximalni hostova zizen v poctech piv */
    private static final int MAXIMAL_GUESTS_THIRST = 3;

    /** maximalni pocet hostu */
    private static final int NUMBER_OF_GUESTS = 7;

    /** maximalni pocet obsluhujicich cisniku */
    private static final int NUMBER_OF_WAITERS = 2;

    public static void main( String[] args ) throws InterruptedException {

        // vytvor cisniky
        List<Thread> waiters = new ArrayList<Thread>();
        for ( int i = 1; i <= NUMBER_OF_WAITERS; ++i ) {
            Waiter waiter = new Waiter( "CISNIK-" + i );
            waiters.add( start( "CISNIK-" + i, waiter ) );
        }

        // vytvor stoly
        List<Table> tables = new ArrayList<Table>();
        for ( int i = 1; i <= NUMBER_OF_TABLES; ++i )
            tables.add( new Table( "STUL-" + i ) );

        // zahajeni provozu
        System.out.println( "[HOSPODA] Otevrela." );

        // vytvor hosty
        List<Thread> guests = new ArrayList<Thread>();
        for ( int i = 1; i <= NUMBER_OF_GUESTS; ++i ) {
            // urci hostovu zizen
            int thirst = ( ( int ) ( Math.random() * 100 ) ) % MAXIMAL_GUESTS_THIRST + 1;
            // pojmenuj hosta
            String name = "GUEST-" + i;
            // vyber mu stul
            Table table = tables.get( ( i - 1 ) % NUMBER_OF_TABLES );
            // posli ho do hospody
            Guest guest = new Guest( name, thirst, table );
            guests.add( start( name, guest ) );
        }

        // pockej az vsichni hoste dopiji
        for ( Thread guest : guests ) guest.join();

        // ukonci praci cisniku
       for ( Thread waiter : waiters ) waiter.interrupt();

        // pockej az cisnici skutecne skonci
        for ( Thread waiter : waiters ) waiter.join();

        // zavri hospodu
        System.out.println( "[HOSPODA] Pro dnesek uz zavirame." );
    }

    private static Thread start( String name, Runnable runnable ) {
        Thread t = new Thread(runnable, name);
        t.start(); // !!!!!!!!!!!!!!!!!!!!!
        return t;
    }
}
